```python
#changement de répertoire
import os
os.chdir("C:/Users/Zatovo/Desktop/demo")

#chargement des données d'apprentissage
import pandas
D = pandas.read_excel("wavenoise.xlsx", sheet_name = 0)

#information
D.info()
```

    <class 'pandas.core.frame.DataFrame'>
    RangeIndex: 5000 entries, 0 to 4999
    Data columns (total 43 columns):
     #   Column  Non-Null Count  Dtype  
    ---  ------  --------------  -----  
     0   ONDE    5000 non-null   object 
     1   V01     5000 non-null   float64
     2   V01b    5000 non-null   float64
     3   V02     5000 non-null   float64
     4   V02b    5000 non-null   float64
     5   V03     5000 non-null   float64
     6   V03b    5000 non-null   float64
     7   V04     5000 non-null   float64
     8   V04b    5000 non-null   float64
     9   V05     5000 non-null   float64
     10  V05b    5000 non-null   float64
     11  V06     5000 non-null   float64
     12  V06b    5000 non-null   float64
     13  V07     5000 non-null   float64
     14  V07b    5000 non-null   float64
     15  V08     5000 non-null   float64
     16  V08b    5000 non-null   float64
     17  V09     5000 non-null   float64
     18  V09b    5000 non-null   float64
     19  V10     5000 non-null   float64
     20  V10b    5000 non-null   float64
     21  V11     5000 non-null   float64
     22  V11b    5000 non-null   float64
     23  V12     5000 non-null   float64
     24  V12b    5000 non-null   float64
     25  V13     5000 non-null   float64
     26  V13b    5000 non-null   float64
     27  V14     5000 non-null   float64
     28  V14b    5000 non-null   float64
     29  V15     5000 non-null   float64
     30  V15b    5000 non-null   float64
     31  V16     5000 non-null   float64
     32  V16b    5000 non-null   float64
     33  V17     5000 non-null   float64
     34  V17b    5000 non-null   float64
     35  V18     5000 non-null   float64
     36  V18b    5000 non-null   float64
     37  V19     5000 non-null   float64
     38  V19b    5000 non-null   float64
     39  V20     5000 non-null   float64
     40  V20b    5000 non-null   float64
     41  V21     5000 non-null   float64
     42  V21b    5000 non-null   float64
    dtypes: float64(42), object(1)
    memory usage: 1.6+ MB
    


```python
#partition apprentissage test
from sklearn import model_selection
DTrain, DTest = model_selection.train_test_split(D, train_size=3500, random_state = 0)

#vérifications
print(DTrain.shape)
print(DTest.shape)
```

    (3500, 43)
    (1500, 43)
    


```python
#distribution des classes sur TRAIN
print(DTrain.ONDE.value_counts())
```

    A    1183
    C    1162
    B    1155
    Name: ONDE, dtype: int64
    


```python
#partition pour 1ere variable
xa = DTrain.V01[DTrain.ONDE=='A']
xb = DTrain.V01[DTrain.ONDE=='B']
xc = DTrain.V01[DTrain.ONDE=='C']

#anova avec Scipy
from scipy.stats import f_oneway
print(f_oneway(xa,xb,xc))
```

    F_onewayResult(statistic=0.2833465691429724, pvalue=0.7532759782911986)
    


```python
#sélection de variables - filtrage
from sklearn.feature_selection import SelectFwe,f_classif
sel = SelectFwe(f_classif,alpha=0.001)
sel.fit(DTrain[DTrain.columns[1:]],DTrain.ONDE)
```




    SelectFwe(alpha=0.001)




```python
#les scores
print(sel.scores_)
```

    [2.83346569e-01 8.12102967e-01 9.79241725e+01 7.19554754e-01
     2.90636258e+02 1.77269782e+00 5.72917104e+02 9.57407062e-02
     8.35087079e+02 1.05524423e+00 9.39986083e+02 8.70137392e-01
     1.03067982e+03 1.18915153e+00 9.39349481e+02 1.12884976e+00
     8.17681282e+02 2.53519212e+00 7.20891031e+02 3.29077453e+00
     7.90338440e+02 6.32376043e-02 7.11243482e+02 1.10510763e-01
     8.43174831e+02 2.42456270e-01 8.73785410e+02 1.81243671e+00
     9.85652269e+02 6.25584901e-01 8.64027087e+02 6.23745361e-01
     8.42424955e+02 2.35642691e-01 6.06503872e+02 1.50390130e-01
     2.65983617e+02 5.80644632e-01 9.95681690e+01 2.03544751e+00
     1.78604360e-01 6.93498972e-01]
    


```python
#les p-value
print(sel.pvalues_)
```

    [7.53275978e-001 4.44007230e-001 4.17136309e-042 4.87041114e-001
     1.71436293e-117 1.70026698e-001 6.04547425e-216 9.08701988e-001
     3.37884687e-297 3.48218218e-001 0.00000000e+000 4.18984667e-001
     0.00000000e+000 3.04602586e-001 0.00000000e+000 3.23522855e-001
     4.59160266e-292 7.93921343e-002 7.20251398e-263 3.73403150e-002
     6.25826820e-284 9.38721477e-001 6.76111063e-260 8.95379820e-001
     1.43001978e-299 7.84711252e-001 1.73363703e-308 1.63409166e-001
     0.00000000e+000 5.35008301e-001 1.17504231e-305 5.35993024e-001
     2.37185566e-299 7.90075464e-001 7.47323218e-227 8.60377818e-001
     2.95506106e-108 5.59591491e-001 8.79965602e-043 1.30776739e-001
     8.36444391e-001 4.99892862e-001]
    


```python
#lister les variables sélectionnées
print(DTrain.columns[1:][sel.pvalues_ < 0.001])
```

    Index(['V02', 'V03', 'V04', 'V05', 'V06', 'V07', 'V08', 'V09', 'V10', 'V11',
           'V12', 'V13', 'V14', 'V15', 'V16', 'V17', 'V18', 'V19', 'V20'],
          dtype='object')
    


```python
#construire la matrice X avec les var. sél. pour l'apprentissage
XTrainSel = sel.transform(DTrain[DTrain.columns[1:]])
print(XTrainSel.shape)
```

    (3500, 19)
    


```python
#analyse discriminante
from sklearn.discriminant_analysis import LinearDiscriminantAnalysis
lda  = LinearDiscriminantAnalysis()

#apprentissage avec les var. sélectionnées
lda.fit(XTrainSel,DTrain.ONDE)

#coefficients
print(lda.coef_)
```

    [[ 0.02355622  0.07375746  0.07554345  0.10877949  0.14377926  0.10688457
      -0.01904822 -0.17589723 -0.22730174 -0.26748252 -0.22744865 -0.16119897
      -0.01464809  0.06132211  0.07479197  0.18737743  0.09084393  0.02794061
       0.0228686 ]
     [ 0.00944657 -0.03331286  0.03797953  0.0437289   0.03222902  0.04920104
       0.17237599  0.16328853  0.16651593  0.15882044  0.05577705 -0.01151391
      -0.10215165 -0.09751241 -0.1045239  -0.19251819 -0.14559535 -0.00231139
      -0.06352789]
     [-0.0333716  -0.04197825 -0.11465943 -0.15421086 -0.17841255 -0.15772087
      -0.15194512  0.01677123  0.06589677  0.11445285  0.17611813  0.17555676
       0.11644909  0.03449465  0.0277506   0.00059467  0.05223258 -0.02614809
       0.03986331]]
    


```python
#construire la matrice X avec les var. sél. pour le test
XTestSel = sel.transform(DTest[DTest.columns[1:]])
print(XTestSel.shape)
```

    (1500, 19)
    


```python
#prédiction en test
pred = lda.predict(XTestSel)
```


```python
#matrice de confusion
from sklearn import metrics
print(metrics.confusion_matrix(DTest.ONDE,pred))
```

    [[372  53  49]
     [ 29 434  29]
     [ 26  28 480]]
    


```python
#taux de reconnaissance
print(metrics.accuracy_score(DTest.ONDE, pred))
```

    0.8573333333333333
    


```python

```
